Subject: Re: [PATCH v5 0/4] Raspberry Pi 4 DMA addressing support

From: Nicolas Saenz Julienne <[email-masked]>
Date: Mon, 09 Sep 2019 21:50:47 +0200

On Mon, 2019-09-09 at 21:33 +0200, Stefan Wahren wrote:
> Hi Nicolas,
> 
> Am 09.09.19 um 11:58 schrieb Nicolas Saenz Julienne:
> > Hi all,
> > this series attempts to address some issues we found while bringing up
> > the new Raspberry Pi 4 in arm64 and it's intended to serve as a follow
> > up of these discussions:
> > v4: https://lkml.org/lkml/2019/9/6/352
> > v3: https://lkml.org/lkml/2019/9/2/589
> > v2: https://lkml.org/lkml/2019/8/20/767
> > v1: https://lkml.org/lkml/2019/7/31/922
> > RFC: https://lkml.org/lkml/2019/7/17/476
> > 
> > The new Raspberry Pi 4 has up to 4GB of memory but most peripherals can
> > only address the first GB: their DMA address range is
> > 0xc0000000-0xfc000000 which is aliased to the first GB of physical
> > memory 0x00000000-0x3c000000. Note that only some peripherals have these
> > limitations: the PCIe, V3D, GENET, and 40-bit DMA channels have a wider
> > view of the address space by virtue of being hooked up trough a second
> > interconnect.
> > 
> > Part of this is solved on arm32 by setting up the machine specific
> > '.dma_zone_size = SZ_1G', which takes care of reserving the coherent
> > memory area at the right spot. That said no buffer bouncing (needed for
> > dma streaming) is available at the moment, but that's a story for
> > another series.
> > 
> > Unfortunately there is no such thing as 'dma_zone_size' in arm64. Only
> > ZONE_DMA32 is created which is interpreted by dma-direct and the arm64
> > arch code as if all peripherals where be able to address the first 4GB
> > of memory.
> > 
> > In the light of this, the series implements the following changes:
> > 
> > - Create both DMA zones in arm64, ZONE_DMA will contain the first 1G
> >   area and ZONE_DMA32 the rest of the 32 bit addressable memory. So far
> >   the RPi4 is the only arm64 device with such DMA addressing limitations
> >   so this hardcoded solution was deemed preferable.
> > 
> > - Properly set ARCH_ZONE_DMA_BITS.
> > 
> > - Reserve the CMA area in a place suitable for all peripherals.
> > 
> > This series has been tested on multiple devices both by checking the
> > zones setup matches the expectations and by double-checking physical
> > addresses on pages allocated on the three relevant areas GFP_DMA,
> > GFP_DMA32, GFP_KERNEL:
> > 
> > - On an RPi4 with variations on the ram memory size. But also forcing
> >   the situation where all three memory zones are nonempty by setting a 3G
> >   ZONE_DMA32 ceiling on a 4G setup. Both with and without NUMA support.
> > 
> i like to test this series on Raspberry Pi 4 and i have some questions
> to get arm64 running:
> 
> Do you use U-Boot? Which tree?

No, I boot directly.

> Are there any config.txt tweaks necessary?

I'm using the foundation's arm64 stub. Though I'm not 100% it's needed anymore
with the latest firmware.

config.txt:
	arm_64bit=1
	armstub=armstub8-gic.bin
	enable_gic=1
	enable_uart=1

Apart from that the series is based on today's linux-next plus your RPi4
bringup patches.

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel